//---------------------------------------------------------------------------
#ifndef navimainH
#define navimainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>

#include "rtklib.h"
#include <Buttons.hpp>
#include <Graphics.hpp>
#include <ComCtrls.hpp>
#include <Dialogs.hpp>
#include <ImgList.hpp>
#include <Menus.hpp>

#define MAXSCALE	18
#define MAXMAPPNT	10

//---------------------------------------------------------------------------
class TMainForm : public TForm
{
__published:
	TButton *BtnStart;
	TButton *BtnStop;
	TButton *BtnExit;
	TButton *BtnOpt;
	TPanel *Panel1;
	TLabel *LabelTime;
	TTimer *Timer;
	TPanel *Str1;
	TPanel *Str2;
	TPanel *Str4;
	TPanel *Str3;
	TPanel *Svr;
	TPanel *Panel2;
	TPanel *Panel21;
	TLabel *Plabel0;
	TPanel *Panel22;
	TPanel *Panel3;
	TLabel *Message;
	TSpeedButton *BtnSolType;
	TImage *Image1;
	TImage *Image2;
	TPanel *Panel211;
	TLabel *PlabelA;
	TLabel *Plabel1;
	TLabel *Pos1;
	TLabel *Pos2;
	TLabel *Plabel2;
	TLabel *Plabel3;
	TLabel *Pos3;
	TLabel *LabelStd;
	TPanel *Str5;
	TPanel *Str6;
	TScrollBar *ScbSol;
	TSpeedButton *BtnMonitor;
	TButton *BtnSave;
	TSaveDialog *SaveDialog;
	TImage *Disp;
	TImage *Plot;
	TPanel *IndSol;
	TLabel *LabelNSat;
	TSpeedButton *BtnAbout;
	TSpeedButton *BtnPlotType;
	TButton *BtnMap;
	TTrayIcon *TrayIcon;
	TPopupMenu *PopupMenu;
	TImageList *ImageList;
	TMenuItem *MenuExpand;
	TMenuItem *N1;
	TMenuItem *MenuStart;
	TMenuItem *MenuMap;
	TMenuItem *N2;
	TMenuItem *MenuExit;
	TMenuItem *MenuStop;
	TSpeedButton *BtnTaskTray;
	TMenuItem *MenuMonitor;
	TSpeedButton *SpeedButton1;
	TPanel *Panel4;
	TSpeedButton *BtnInputStr;
	TPanel *Panel5;
	TSpeedButton *BtnOutputStr;
	TPanel *Panel7;
	TSpeedButton *BtnTimeSys;
	TLabel *Solution;
	TPanel *Panel6;
	TSpeedButton *BtnLogStr;
	void __fastcall BtnExitClick(TObject *Sender);
	void __fastcall BtnStartClick(TObject *Sender);
	void __fastcall BtnStopClick(TObject *Sender);
	void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
	void __fastcall BtnInputStrClick(TObject *Sender);
	void __fastcall TimerTimer(TObject *Sender);
	void __fastcall BtnTimeSysClick(TObject *Sender);
	void __fastcall BtnSolTypeClick(TObject *Sender);
	void __fastcall BtnPlotTypeClick(TObject *Sender);
	void __fastcall BtnOptClick(TObject *Sender);
	void __fastcall BtnMonitorClick(TObject *Sender);
	void __fastcall ScbSolChange(TObject *Sender);
	void __fastcall BtnSaveClick(TObject *Sender);
	void __fastcall BtnAboutClick(TObject *Sender);
	void __fastcall BtnMapClick(TObject *Sender);
	void __fastcall BtnTaskTrayClick(TObject *Sender);
	void __fastcall TrayIconDblClick(TObject *Sender);
	void __fastcall TrayIconMouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
	void __fastcall MenuExpandClick(TObject *Sender);
	void __fastcall MenuStartClick(TObject *Sender);
	void __fastcall MenuStopClick(TObject *Sender);
	void __fastcall MenuMapClick(TObject *Sender);
	void __fastcall MenuExitClick(TObject *Sender);
	void __fastcall MenuMonitorClick(TObject *Sender);
	void __fastcall FormCreate(TObject *Sender);
	void __fastcall FormShow(TObject *Sender);
	void __fastcall BtnOutputStrClick(TObject *Sender);
	void __fastcall BtnLogStrClick(TObject *Sender);
private:
	int SvrCycle,SvrBuffSize,Scale,SolBuffSize,NavSelect,SbasSat,SavedSol;
	int NmeaReq,NmeaCycle,InTimeTag,OutTimeTag,OutAppend,LogTimeTag,LogAppend;
	int TimeoutTime,ReconTime,SbasCorr,DgpsCorr;
	int Stream[MAXSTRRTK],Format[MAXSTRRTK],CmdEna[2][2],TimeSys,SolType,PlotType;
	int PSol,PSolS,PSolE,Nsat[2],SolCurrentStat;
	int Sat[2][MAXSAT],Snr1[2][MAXSAT],Snr2[2][MAXSAT],Vsat[2][MAXSAT];
	double Az[2][MAXSAT],El[2][MAXSAT];
	gtime_t *Time;
	int *SolStat,*Nvsat;
	double *SolRov,*SolRef,*Qr,*VelRov,*Age,*Ratio;
	AnsiString Paths[MAXSTRRTK][3],Cmds[2][2],InTimeStart,InTimeSpeed,ExSats;
	prcopt_t PrcOpt;
	solopt_t SolOpt;
	TFont *PosFont;
	int DebugTraceF,RovPosTypeF,RefPosTypeF,RovAntPcvF,RefAntPcvF;
	AnsiString RovAntF,RefAntF,AntPcvFileF;
	double RovAntDel[3],RefAntDel[3],RovPos[3],RefPos[3],NmeaPos[2];
	AnsiString History[10],MntpHist[10];
	void __fastcall UpdateLog(int stat, gtime_t time, double *rr, double *qr,
		double *rb, int ns, double age, double ratio);
	void __fastcall SvrStart(void);
	void __fastcall SvrStop(void);
	void __fastcall UpdateTimeSys(void);
	void __fastcall UpdateSolType(void);
	void __fastcall UpdateFont(void);
	void __fastcall UpdateTime(void);
	void __fastcall UpdatePos(void);
	void __fastcall UpdateStr(void);
	void __fastcall UpdatePlot(void);
	void __fastcall ChangePlot(void);
	void __fastcall DrawSnr(TCanvas *c, int w, int h, int top, int index);
	void __fastcall DrawSat(TCanvas *c, int w, int h, int index);
	void __fastcall DrawSky(TCanvas *c, int w, int h);
	void __fastcall DrawText(TCanvas *c, int x, int y, AnsiString s,
		TColor color, int align);
	void __fastcall InitSolBuff(void);
	void __fastcall SaveLog(void);
	void __fastcall LoadNav(nav_t *nav);
	void __fastcall SaveNav(nav_t *nav);
	void __fastcall SetTrayIcon(int index);
public:
	AnsiString StaPosFileF,GoogleEarthFileF;
	AnsiString PntName[MAXMAPPNT];
	double PntPos[MAXMAPPNT][3];
	int NMapPnt;
	void __fastcall UpdateMap(void);
	__fastcall TMainForm(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TMainForm *MainForm;
//---------------------------------------------------------------------------
#endif
