function testpeph

td=caltomjd([2008,3,1]);
time=0:30:86400-30;

ephs=textread('testpeph.out');
ephs(ephs==0)=nan;

sat=sprintf('GPS%02d',ephs(1,1));
ephr=readeph(td,time,{sat},'','igs',24,'interp');

dpos=ephs(:,3:5)-ephr(:,1:3);

figure, hold on, box on, grid on
plot(time/3600,dpos)
xlabel('time (hr)');
ylabel('error (m)');
xlim(time([1,end])/3600);
ylim([-0.01,0.01]);
legend({'x','y','z'})
text(0.02,0.95,sprintf('std:x=%.4f y=%.4f z=%.4f',std(dpos(~isnan(dpos(:,1)),:))),...
     'units','normalized')
moveax
